﻿-- Author      : Nogarder
-- Create Date : 2013/4/25 16:16:23
-- Author      : Nogarder
-- Create Date : 2013/4/20 16:50:44
NPA_Options.RegisterPageFunc("ProfilePorter",function()
	--localization
	local Localization=NPA_Options.Localization.PagesMainProfilePorter
	local Tooltips=Localization.Tooltips
	---
	local parent=NPA_Options.MainFrame
	--main page
	local main=NPA_Options.Template.CreateFrameWithBar(parent,nil,100,80,nil,nil,nil,nil)
	main:SetPoint("CENTER",parent,"CENTER",-60,120)
	main:Hide()
	--
	local page=main.Frame
	page:SetWidth(100)
	page:SetHeight(80)
	local width=90
	local step=-5
	--export button
	local exportbutton=NPA_Options.Template.CreateButton(page,width,15,Localization["Export"])
	exportbutton:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	NPA_Options.Template.SetTooltips(Tooltips["Export"],exportbutton,nil,2)
	NPA_Options.SetPageButton(exportbutton,"ProfileExporter",main)
	--inport button
	local inportbutton=NPA_Options.Template.CreateButton(page,width,15,Localization["Inport"])
	inportbutton:SetPoint("TOPLEFT",exportbutton,"BOTTOMLEFT",0,-5)
	NPA_Options.Template.SetTooltips(Tooltips["Inport"],inportbutton,nil,2)
	NPA_Options.SetPageButton(inportbutton,"ProfileInporter",main)
	--
	NPA_Options.RegisterPage("ProfilePorter",main)
end)
