﻿-- Author      : Nogarder
-- Create Date : 2012/11/4 7:53:23
NPA_Options.RegisterPageFunc("SpellLibLibEditor",function()

	local pairs=pairs
	local CopyTable=CopyTable
	local table_insert=table.insert
	--localization
	local Localization=NPA_Options.Localization.PagesSpellLibLibEditor
	local Tooltips=Localization.Tooltips
	---
	local parent=NPA_Options.MainFrame
	--
	local main=NPA_Options.Template.CreateFrameWithBar(parent,Localization["SelectType"],150,240,nil,nil,nil)
	main:Hide()
	local listeditor=NPA_Options.Template.CreateListEditor(main.Frame,nil,150,240,main,nil,true)
	--script
	local Refresh=function()
		local data=NPA_Options.InfoLib.Spell.GetCatalogList(true)
		NPA_Options.Template.UpdateListEditor(listeditor,data)
	end
	--
	listeditor.RefreshFunc=Refresh
	listeditor.OnClickFunc=function(value,button)
		if(button=="LeftButton")then
			--setup editor page
			NPA_Options.SetPage("SpellSelector",main,value,nil,Refresh)
		end
	end

	--
	main.OnSetFunc=function(name)
		if(name)then
			Refresh()
			NPA_Options.Template.SetSelectListFocus(listeditor,name)
			NPA_Options.SetPage("SpellSelector",main,name,nil,Refresh)
		end
	end
	----
	NPA_Options.RegisterPage("SpellLibLibEditor",main)

end)